#!/usr/bin/env ruby
module Dhaka
  class Production

    attr_reader :symbol, :expansion, :name, :precedence

    def initialize(symbol, expansion, name, precedence = nil)
      @symbol = symbol
      @expansion = expansion
      @name = name
      if precedence
        @precedence = precedence
      else
        @expansion.reverse_each do |symbol|
          if symbol.terminal
            @precedence = symbol.precedence
            break
          end
        end 
      end
    end

    def to_s
      "#{@name} #{@symbol} ::= #{@expansion.join(' ')}"
    end

  end
end