module Dhaka
  class CompiledParser

    def self.inherited(compiled_parser)
      class << compiled_parser
        attr_accessor :states, :grammar, :start_state_id
      end
      compiled_parser.states = Hash.new {|hash, state_id| hash[state_id] = ParserState.new(compiled_parser, {}, state_id)}
    end

    def self.at_state x, &blk
      self.states[x].instance_eval(&blk)
    end
  
    def self.start_state
      states[start_state_id]
    end
  
    def self.start_with start_state_id
      self.start_state_id = start_state_id
    end
  
    def self.reduce_with production_name
      ReduceAction.new(grammar.production_named(production_name))
    end
  
    def self.shift_to state_id
      ShiftAction.new(states[state_id])
    end
  
    self.extend(ParserMethods)
  
  end

end