require File.dirname(__FILE__)+'/../lib/dhaka'
require 'arithmetic_grammar'

class ArithmeticEvaluator < Dhaka::Evaluator
  
  self.grammar = ArithmeticGrammar
  
  define_evaluation_rules do
    
    for_subtraction do 
      child_nodes[0] - child_nodes[2]
    end

    for_addition do
      child_nodes[0] + child_nodes[2]
    end

    for_division do
      child_nodes[0].to_f/child_nodes[2] 
    end

    for_multiplication do
      child_nodes[0] * child_nodes[2]
    end

    for_getting_literals do
      child_nodes[0].token.value
    end

    for_unpacking_parenthetized_expression do
      child_nodes[1]
    end
    
    for_empty_args do
      []
    end

    for_evaluating_function do
      child_nodes[0].call child_nodes[2]
    end
  
    for_concatenating_args do
      [child_nodes[0]]+child_nodes[2]
    end
  
    for_single_args do
      [child_nodes[0]]
    end
  
    for_min_function do
      @min_function
    end
  
    for_max_function do
      @max_function
    end

  end
  
  def initialize(syntax_tree, min_function, max_function)
    @min_function = min_function
    @max_function = max_function
    super(syntax_tree)
  end

end
