require File.dirname(__FILE__)+'/../lib/dhaka'

class ArithmeticGrammar < Dhaka::Grammar
  for_symbol(Dhaka::START_SYMBOL_NAME) do
    expression ['E']
  end
  for_symbol('E') do
    subtraction ['E', '-', 'T']
    addition ['E', '+', 'T']
    term ['T']
  end
  for_symbol('T') do
    factor ['F']
    division ['T', '/', 'F']
    multiplication ['T', '*', 'F']
  end
  for_symbol('F') do
    getting_literals ['n']
    unpacking_parenthetized_expression ['(', 'E', ')']
    function ['Function']
  end
  for_symbol('Function') do
    evaluating_function ['FunctionName', '(', 'Args', ')']
  end
  for_symbol('FunctionName') do
    max_function ['h']
    min_function ['l']
  end
  for_symbol('Args') do
    empty_args []
    single_args ['E']
    concatenating_args ['E', ',', 'Args']
  end
end

