require File.dirname(__FILE__)+'/../lib/dhaka'
require 'arithmetic_precedence_grammar'

class ArithmeticPrecedenceEvaluator < Dhaka::Evaluator
  
  self.grammar = ArithmeticPrecedenceGrammar
  
  define_evaluation_rules do
    
    for_subtraction do 
      child_nodes[0] - child_nodes[2]
    end

    for_addition do
      child_nodes[0] + child_nodes[2]
    end

    for_division do
      child_nodes[0].to_f/child_nodes[2] 
    end

    for_multiplication do
      child_nodes[0] * child_nodes[2]
    end

    for_literal do
      child_nodes[0].token.value
    end

    for_parenthetized_expression do
      child_nodes[1]
    end
    
    for_negated_expression do
      -child_nodes[1]
    end

  end

end
