require "test/unit"
require "arithmetic_precedence_grammar"
require "arithmetic_tokenizer"
require "arithmetic_precedence_evaluator"

class TestArithmeticPrecedenceParser < Test::Unit::TestCase

  def test_parses_arithmetic_expressions
    fake_logger = FakeLogger.new
    parser = Dhaka::Parser.new(ArithmeticPrecedenceGrammar, fake_logger)
    assert_equal(20, fake_logger.messages.size)
    
    syntax_tree = parser.parse(ArithmeticTokenizer.tokenize("5 * -14/(2*7 - 7) + 2")).syntax_tree
#    File.open('precedence.dot', 'w') {|file| file << syntax_tree.to_dot}
#    File.open('precedence_parser.dot', 'w') {|file| file << parser.to_dot}
    assert_equal(-8, ArithmeticPrecedenceEvaluator.new(syntax_tree).result)
  end
end

class FakeLogger
  attr_reader :messages
  def initialize
    @messages = []
  end
  def debug message
  end
  def warn(message)
    @messages << message
  end
end