require File.dirname(__FILE__)+'/../lib/dhaka'
require 'arithmetic_grammar'


class ArithmeticTokenizer < Dhaka::Tokenizer
  
  digits = ('0'..'9').to_a
  parenths = ['(', ')']
  operators = ['-', '+', '/', '*']
  functions = ['h', 'l']
  arg_separator = [',']
  whitespace = [' ']

  all_characters = digits + parenths + operators + functions + arg_separator + whitespace

  for_state :idle_state do
    for_characters(all_characters - (digits + whitespace)) do
      tokens << Dhaka::Token.new(ArithmeticGrammar.symbol_for_name(curr_char), nil)
      advance
    end
    for_characters digits do
      self.accumulator = ''
      switch_to :get_integer_literal
    end
    for_character whitespace do
      advance
    end
  end
  
  for_state :get_integer_literal do
    for_characters all_characters - digits do
      tokens << Dhaka::Token.new(ArithmeticGrammar.symbol_for_name('n'), accumulator.to_i)
      switch_to :idle_state
    end
    for_characters digits do
      self.accumulator += curr_char
      advance
      tokens << Dhaka::Token.new(ArithmeticGrammar.symbol_for_name('n'), accumulator.to_i) unless curr_char
    end
  end
  
end

