require "test/unit"

require "bracket_grammar"
require 'bracket_tokenizer'

class TestBracketGrammar < Test::Unit::TestCase
  def test_recognizes_faulty_bracket_configuration_correctly
    eval Dhaka::Parser.new(BracketGrammar).compile_to_ruby_source_as(:BracketParser)
    assert correct("[{(B)[B]}(B)]")
    assert correct("[[B]{(B)}(B)]")
    assert correct("{(B)[B]}")
    assert !correct("{B[B]}")
    assert !correct("B")
    assert !correct("[[B]{(B)}}(B)]")
  end
  def correct input_string
    result = BracketParser.parse(BracketTokenizer.tokenize(input_string))
    !result.has_error?
  end
end