require File.dirname(__FILE__)+'/../lib/dhaka'
require 'arithmetic_grammar'

class CompiledArithmeticParser < Dhaka::CompiledParser

  self.grammar = ArithmeticGrammar

  start_with 11

  at_state(21) {
    for_symbol('l') { shift_to 16 }
    for_symbol('FunctionName') { shift_to 23 }
    for_symbol('n') { shift_to 12 }
    for_symbol('Function') { shift_to 31 }
    for_symbol('F') { shift_to 22 }
    for_symbol('(') { shift_to 17 }
    for_symbol('h') { shift_to 13 }
  }

  at_state(28) {
    for_symbol('l') { shift_to 16 }
    for_symbol('FunctionName') { shift_to 23 }
    for_symbol('n') { shift_to 12 }
    for_symbol('E') { shift_to 27 }
    for_symbol('Function') { shift_to 31 }
    for_symbol('F') { shift_to 30 }
    for_symbol('Args') { shift_to 29 }
    for_symbol('(') { shift_to 17 }
    for_symbol('h') { shift_to 13 }
    for_symbol(')') { reduce_with 'empty_args' }
    for_symbol('T') { shift_to 14 }
  }

  at_state(17) {
    for_symbol('l') { shift_to 16 }
    for_symbol('FunctionName') { shift_to 23 }
    for_symbol('n') { shift_to 12 }
    for_symbol('E') { shift_to 18 }
    for_symbol('Function') { shift_to 31 }
    for_symbol('F') { shift_to 30 }
    for_symbol('(') { shift_to 17 }
    for_symbol('h') { shift_to 13 }
    for_symbol('T') { shift_to 14 }
  }

  at_state(23) {
    for_symbol('(') { shift_to 24 }
  }

  at_state(16) {
    for_symbol('(') { reduce_with 'min_function' }
  }

  at_state(13) {
    for_symbol('(') { reduce_with 'max_function' }
  }

  at_state(20) {
    for_symbol('+') { reduce_with 'addition' }
    for_symbol(',') { reduce_with 'addition' }
    for_symbol('-') { reduce_with 'addition' }
    for_symbol('/') { shift_to 15 }
    for_symbol('_End_') { reduce_with 'addition' }
    for_symbol(')') { reduce_with 'addition' }
    for_symbol('*') { shift_to 21 }
  }

  at_state(34) {
    for_symbol('+') { reduce_with 'unpacking_parenthetized_expression' }
    for_symbol(',') { reduce_with 'unpacking_parenthetized_expression' }
    for_symbol('-') { reduce_with 'unpacking_parenthetized_expression' }
    for_symbol('/') { reduce_with 'unpacking_parenthetized_expression' }
    for_symbol('_End_') { reduce_with 'unpacking_parenthetized_expression' }
    for_symbol(')') { reduce_with 'unpacking_parenthetized_expression' }
    for_symbol('*') { reduce_with 'unpacking_parenthetized_expression' }
  }

  at_state(32) {
    for_symbol('l') { shift_to 16 }
    for_symbol('FunctionName') { shift_to 23 }
    for_symbol('n') { shift_to 12 }
    for_symbol('Function') { shift_to 31 }
    for_symbol('F') { shift_to 30 }
    for_symbol('(') { shift_to 17 }
    for_symbol('h') { shift_to 13 }
    for_symbol('T') { shift_to 33 }
  }

  at_state(15) {
    for_symbol('l') { shift_to 16 }
    for_symbol('FunctionName') { shift_to 23 }
    for_symbol('n') { shift_to 12 }
    for_symbol('Function') { shift_to 31 }
    for_symbol('F') { shift_to 35 }
    for_symbol('(') { shift_to 17 }
    for_symbol('h') { shift_to 13 }
  }

  at_state(33) {
    for_symbol('+') { reduce_with 'subtraction' }
    for_symbol(',') { reduce_with 'subtraction' }
    for_symbol('-') { reduce_with 'subtraction' }
    for_symbol('/') { shift_to 15 }
    for_symbol('_End_') { reduce_with 'subtraction' }
    for_symbol(')') { reduce_with 'subtraction' }
    for_symbol('*') { shift_to 21 }
  }

  at_state(24) {
    for_symbol('l') { shift_to 16 }
    for_symbol('FunctionName') { shift_to 23 }
    for_symbol('n') { shift_to 12 }
    for_symbol('E') { shift_to 27 }
    for_symbol('Function') { shift_to 31 }
    for_symbol('F') { shift_to 30 }
    for_symbol('Args') { shift_to 25 }
    for_symbol('(') { shift_to 17 }
    for_symbol('h') { shift_to 13 }
    for_symbol(')') { reduce_with 'empty_args' }
    for_symbol('T') { shift_to 14 }
  }

  at_state(11) {
    for_symbol('l') { shift_to 16 }
    for_symbol('FunctionName') { shift_to 23 }
    for_symbol('n') { shift_to 12 }
    for_symbol('E') { shift_to 36 }
    for_symbol('Function') { shift_to 31 }
    for_symbol('F') { shift_to 30 }
    for_symbol('(') { shift_to 17 }
    for_symbol('h') { shift_to 13 }
    for_symbol('T') { shift_to 14 }
  }

  at_state(35) {
    for_symbol('+') { reduce_with 'division' }
    for_symbol(',') { reduce_with 'division' }
    for_symbol('-') { reduce_with 'division' }
    for_symbol('/') { reduce_with 'division' }
    for_symbol('_End_') { reduce_with 'division' }
    for_symbol(')') { reduce_with 'division' }
    for_symbol('*') { reduce_with 'division' }
  }

  at_state(31) {
    for_symbol('+') { reduce_with 'function' }
    for_symbol(',') { reduce_with 'function' }
    for_symbol('-') { reduce_with 'function' }
    for_symbol('/') { reduce_with 'function' }
    for_symbol('_End_') { reduce_with 'function' }
    for_symbol(')') { reduce_with 'function' }
    for_symbol('*') { reduce_with 'function' }
  }

  at_state(26) {
    for_symbol('+') { reduce_with 'evaluating_function' }
    for_symbol(',') { reduce_with 'evaluating_function' }
    for_symbol('-') { reduce_with 'evaluating_function' }
    for_symbol('/') { reduce_with 'evaluating_function' }
    for_symbol('_End_') { reduce_with 'evaluating_function' }
    for_symbol(')') { reduce_with 'evaluating_function' }
    for_symbol('*') { reduce_with 'evaluating_function' }
  }

  at_state(18) {
    for_symbol('+') { shift_to 19 }
    for_symbol('-') { shift_to 32 }
    for_symbol(')') { shift_to 34 }
  }

  at_state(14) {
    for_symbol('+') { reduce_with 'term' }
    for_symbol(',') { reduce_with 'term' }
    for_symbol('-') { reduce_with 'term' }
    for_symbol('/') { shift_to 15 }
    for_symbol('_End_') { reduce_with 'term' }
    for_symbol(')') { reduce_with 'term' }
    for_symbol('*') { shift_to 21 }
  }

  at_state(25) {
    for_symbol(')') { shift_to 26 }
  }

  at_state(22) {
    for_symbol('+') { reduce_with 'multiplication' }
    for_symbol(',') { reduce_with 'multiplication' }
    for_symbol('-') { reduce_with 'multiplication' }
    for_symbol('/') { reduce_with 'multiplication' }
    for_symbol('_End_') { reduce_with 'multiplication' }
    for_symbol(')') { reduce_with 'multiplication' }
    for_symbol('*') { reduce_with 'multiplication' }
  }

  at_state(12) {
    for_symbol('+') { reduce_with 'getting_literals' }
    for_symbol(',') { reduce_with 'getting_literals' }
    for_symbol('-') { reduce_with 'getting_literals' }
    for_symbol('/') { reduce_with 'getting_literals' }
    for_symbol('_End_') { reduce_with 'getting_literals' }
    for_symbol(')') { reduce_with 'getting_literals' }
    for_symbol('*') { reduce_with 'getting_literals' }
  }

  at_state(36) {
    for_symbol('+') { shift_to 19 }
    for_symbol('-') { shift_to 32 }
    for_symbol('_End_') { reduce_with 'expression' }
  }

  at_state(30) {
    for_symbol('+') { reduce_with 'factor' }
    for_symbol(',') { reduce_with 'factor' }
    for_symbol('-') { reduce_with 'factor' }
    for_symbol('/') { reduce_with 'factor' }
    for_symbol('_End_') { reduce_with 'factor' }
    for_symbol(')') { reduce_with 'factor' }
    for_symbol('*') { reduce_with 'factor' }
  }

  at_state(29) {
    for_symbol(')') { reduce_with 'concatenating_args' }
  }

  at_state(27) {
    for_symbol('+') { shift_to 19 }
    for_symbol(',') { shift_to 28 }
    for_symbol('-') { shift_to 32 }
    for_symbol(')') { reduce_with 'single_args' }
  }

  at_state(19) {
    for_symbol('l') { shift_to 16 }
    for_symbol('FunctionName') { shift_to 23 }
    for_symbol('n') { shift_to 12 }
    for_symbol('Function') { shift_to 31 }
    for_symbol('F') { shift_to 30 }
    for_symbol('(') { shift_to 17 }
    for_symbol('h') { shift_to 13 }
    for_symbol('T') { shift_to 20 }
  }

end