require File.dirname(__FILE__)+'/../lib/dhaka'
require 'arithmetic_grammar'

class ArithmeticEvaluator < Dhaka::Evaluator
  
  self.grammar = ArithmeticGrammar
  
  define_evaluation_rules do
    
    for_subtraction do 
      child_nodes[0] - child_nodes[2]
    end

    for_addition do
      child_nodes[0] + child_nodes[2]
    end

    for_division do
      child_nodes[0].to_f/child_nodes[2] 
    end

    for_multiplication do
      child_nodes[0] * child_nodes[2]
    end

    for_getting_literals do
      child_nodes[0].token.value
    end

    for_start_production do
      child_nodes[0]
    end

    for_empty_args do
      []
    end

    for_evaluating_function do
      child_nodes[0].call child_nodes[2]
    end
  
    for_concatenating_args do
      [child_nodes[0]]+child_nodes[2]
    end
  
    for_single_args do
      [child_nodes[0]]
    end
  
    for_min_function do
      Proc.new {|args| args.inject {|min, elem| min = (elem < min ? elem : min)}}
    end
  
    for_max_function do
      Proc.new {|args| args.inject {|max, elem| max = (elem > max ? elem : max)}}
    end

  end

end
